#include "..\CmnHdr.H"
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"


 POINT P; //  " "


/////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog (HWND hwnd, HWND hwndFocus,
   LPARAM lParam) {

   // Associate an icon with the dialog box.
//   chSETDLGICONS(hwnd, IDI_VMSTAT, IDI_VMSTAT);

   
   SetTimer(hwnd,1,100,NULL);

   return(TRUE);
}



/////////////////////////////////////////////////////////////


void Dlg_OnCommand (HWND hwnd, int id, HWND hwndCtl,
   UINT codeNotify) {

   switch (id) {
      case IDOK:
         EndDialog(hwnd,id);
         break;
   }
}



/////////////////////////////////////////////////////////////


void EnableMenuItems(HMENU hMenu){
 HMENU		hTempMenu;
 int		i;

 for(i=0;i < 100;i++){
   EnableMenuItem(hMenu,i,MF_ENABLED);

   hTempMenu = GetSubMenu(hMenu,i);
   if(hTempMenu == NULL)continue;
      
   EnableMenuItems(hTempMenu);

 }
 

 return;
}


/////////////////////////////////////////////////////////////


void GetChildren(HWND hwndP){
  HWND		h,hT;
  HMENU		MainMenu;


//  ?  
  h = GetWindow(hwndP,GW_CHILD);
  if (h == NULL)return;

  while(h != NULL){
     MainMenu = GetMenu(h);
     if(MainMenu != NULL)EnableMenuItems(MainMenu);  
     EnableWindow(h,TRUE);

     hT = GetWindow(h,GW_CHILD);
	 if(hT == NULL){
       
       h = GetWindow(h,GW_HWNDNEXT);
	   EnableWindow(h,TRUE);
	   continue;

	 }

	 GetChildren(h);	  

     h = GetWindow(h,GW_HWNDNEXT);
	 EnableWindow(h,TRUE);
  }


}



/////////////////////////////////////////////////////////////



HWND FindOldestWindow(HWND hwnd)
{
  HWND hTemp;

  hTemp = GetParent(hwnd);

  if(hTemp == NULL) return hwnd;

  hTemp = FindOldestWindow(hTemp);
  return hTemp; 

};



/////////////////////////////////////////////////////////////


void Dlg_OnTimer(HWND hwnd,UINT id){

  HWND CurWin,ParentWin;
  TCHAR ClName[50] = "",WinHndl[50] = "",WinText[50] = "",
	    ParHndl[50] = "",MenuHndl[50] = "";
  //RECT  rec;
  HMENU MainMenu;

//    
  GetCursorPos(&P);

//  handle  
  CurWin = WindowFromPoint(P);

  if (CurWin == NULL ) return; // ,    

//     
  GetClassName(CurWin,ClName,49);
  
//   16-  handle    
  wsprintf(WinHndl,"%x",(int)CurWin);
  
//    
  GetWindowText(CurWin,WinText,49);

  SetDlgItemText(hwnd,IDC_CURWIN_ED,WinHndl);
  SetDlgItemText(hwnd,IDC_CLNAME_ED,ClName);
  SetDlgItemText(hwnd,IDC_TEXT_ED,WinText);  

//      
//  ,       
   GetChildren(CurWin);

//  handle 
   ParentWin = FindOldestWindow(CurWin);

//  handle  
  wsprintf(ParHndl,"%x",(int)ParentWin);
  SetDlgItemText(hwnd,IDC_PARENT_ED,ParHndl);  

//     ?
   MainMenu = GetMenu(ParentWin);
   if(MainMenu != NULL)EnableMenuItems(MainMenu);  

//  1- .  
  ParentWin = GetWindow(ParentWin,GW_CHILD); 
  ParentWin = GetWindow(ParentWin,GW_HWNDFIRST);

//       
  while(ParentWin != NULL){

//       
//  -     	  
//    
   GetChildren(ParentWin);  

//     ?
   MainMenu = GetMenu(ParentWin);
   if(MainMenu != NULL)EnableMenuItems(MainMenu);  
   EnableWindow(ParentWin,TRUE);

   ParentWin = GetWindow(ParentWin,GW_HWNDNEXT);
	  
}
    

}


/////////////////////////////////////////////////////////////


BOOL CALLBACK Dlg_Proc (HWND hwnd, UINT uMsg,
   WPARAM wParam, LPARAM lParam) {

   switch (uMsg) {
      chHANDLE_DLGMSG(hwnd, WM_INITDIALOG, Dlg_OnInitDialog);
      chHANDLE_DLGMSG(hwnd, WM_COMMAND,    Dlg_OnCommand);
	  chHANDLE_DLGMSG(hwnd, WM_TIMER,	   Dlg_OnTimer);
   
   }
   return(FALSE);
}


/////////////////////////////////////////////////////////////


int WINAPI _tWinMain (HINSTANCE hinstExe,
   HINSTANCE hinstPrev, LPTSTR pszCmdLine, int nCmdShow) {

   chWARNIFUNICODEUNDERWIN95();
   DialogBox(hinstExe, MAKEINTRESOURCE(IDD_DIALOG),
      NULL, Dlg_Proc);

   return(0);
}


//////////////////////// End Of File ////////////////////////



